<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div>
    <div class="navgation display-none">
      <div style="width: 80%; display:flex">
        <div
          class="logo lt"
          style="width: 45%"
          @click="jumpLogoTo"
        >
          <div class="logo-header">
            <span> <strong style="color: #2ececa">KONNEKT</strong></span>
          </div>
        </div>
        <div style="width:40%">
          <el-menu
            class="el-menu-demo"
            mode="horizontal"
            :default-active="activeIndex"
          >
            <el-menu-item
              index="1"
              disabled
            >
              Theme color
            </el-menu-item>
            <el-menu-item
              index="2"
              @click="goTovideoPage()"
            >
              Live
            </el-menu-item>
            <el-menu-item
              index="3"
              @click="loadMaps()"
            >
              Maps
            </el-menu-item>
            <!-- <el-button
              type="primary"
              class="upLoad_btn"
              @click="beforeUpload()"
            >
              Upload
            </el-button> -->
          </el-menu>
        </div>
      </div>
      <!--login form-->
      <el-dialog
        title="UserLogin"
        :visible.sync="loginForm"
      >
        <el-form
          :model="user"
          ref="user"
        >
          <el-form-item
            label="Name"
            prop="name"
          >
            <el-input
              v-model="user.name"
              autocomplete="off"
            />
          </el-form-item>
          <el-form-item
            label="clientIP"
            prop="clientIP"
          >
            <el-input
              v-model="user.clientIP"
              autocomplete="off"
            />
          </el-form-item>
        </el-form>
        <span
          slot="footer"
          class="dialog-footer"
        >
          <el-button @click="hideLogin">Cancel</el-button>
          <el-button
            type="primary"
            @click="userLogin"
          >Login</el-button>
        </span>
      </el-dialog>
      <div class="AddDetais">
        <el-breadcrumb separator="/">
          <el-breadcrumb-item>
            <span
              @click="openLogin()"
            >
              {{ $t('login.login') }}
            </span>
          </el-breadcrumb-item>
          <el-breadcrumb-item>
            <span
              class="highlight"
              @click="openForm()"
            >
              {{ $t('login.register') }}
            </span>
          </el-breadcrumb-item>
        </el-breadcrumb>
      </div>
      <!--add IP Details-->
      <el-dialog
        title="Add IP Details"
        :visible.sync="dialogFormVisible"
      >
        <el-form
          :model="formData"
          ref="formData"
        >
          <el-form-item
            label="Name"
            prop="name"
          >
            <el-input
              v-model="formData.name"
              autocomplete="off"
            />
          </el-form-item>
          <el-form-item
            label="DeviceIP"
            prop="deviceIP"
          >
            <el-input
              v-model="formData.deviceIP"
              autocomplete="off"
            />
          </el-form-item>
          <el-form-item
            label="StreamURL"
            prop="StreamURL"
          >
            <el-input
              v-model="formData.StreamURL"
              autocomplete="off"
            />
          </el-form-item>
        </el-form>
        <span
          slot="footer"
          class="dialog-footer"
        >
          <el-button @click="hideForm">Cancel</el-button>
          <el-button
            type="primary"
            @click="registerDevice"
          >Add</el-button>
        </span>
      </el-dialog>
    </div>
    <!--mobileView Header-->
    <div class="mobile-navgation display-block">
      <div style="width: 100%">
        <div
          class="logo lt"
        >
          <span
            class="el-dropdown-link"
            @click="openSidebar"
          >
            <i
              class="el-icon-s-unfold"
              style="font-size: 40px; color:white; margin-top: 10px"
            />
          </span>
          <el-menu
            :default-active="activeIndex"
            class="el-menu-vertical-demo"
            @open="handleOpen"
            @close="handleClose"
            :collapse="isCollapse"
            :collapse-transition="colTrans"
          >
            <el-menu-item
              index="1"
              @click.native="selTheme()"
              disabled
            >
              <span slot="title">Theme</span>
            </el-menu-item>
            <el-menu-item
              index="2"
              @click.native="goTovideoPage()"
            >
              <span slot="title">Live</span>
            </el-menu-item>
            <el-menu-item
              index="3"
              @click.native="loadMaps()"
            >
              <span slot="title">Maps</span>
            </el-menu-item>
            <el-menu-item
              index="4"
              @click.native="beforeUpload()"
            >
              <span slot="title">upLoad</span>
            </el-menu-item>
          </el-menu>
        </div>
        <div class="logo-header">
          <span @click="jumpLogoTo"> <strong style="color: #2ececa">KONNEKT</strong></span>
          <em
            class="el-icon-user-solid login_icon"
            @click="openForm()"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios'
import io from 'socket.io-client'
import baseUrl from '@/config'
import Constant from '@/constants'
export default {
  name: 'Navgation',
  components: {
  },
  data () {
    return {
      language: 'English',
      isaddVideo: true,
      dialogvideoFrom: false,
      dialogFormVisible: false,
      loginForm: false,
      uploadReady: true,
      isCollapse: true,
      colTrans: true,
      streamVideo: null,
      activeIndex: this.getNavSelected(),
      streamInputData: {},
      user: {
        name: '',
        clientIP: ''
      },
      formData: {
        name: '',
        deviceIP: '',
        StreamURL: ''
      },
      socket: null,
      soundurl: 'http://soundbible.com/mp3/analog-watch-alarm_daniel-simion.mp3',
      locationDetails: {
        lat: '',
        lang: ''
      }
    }
  },
  created () {
    window.addEventListener('resize', this.myEventHandler)
    // Client receives the message:
    let ctx = this
    const proxyURL = baseUrl.baseUrl_NodeProxy
    this.socket = io.connect(proxyURL)
    this.socket.on('notice', (data) => {
      console.log('Proxy to Client')
      this.getLocation()
    })
    this.socket.on('broadcast', function (data) {
      if (data.lat && data.lang) {
        ctx.getNotification(data)
      }
    })
  },
  mounted () {
    this.getNavSelected()
    this.getIpAddress()
  },
  destroyed () {
    window.removeEventListener('resize', this.myEventHandler)
  },
  watch: {
  },
  methods: {
    getNavSelected () {
      let url = document.location.hash
      switch (url) {
        case '#/live':
          this.activeIndex = '2'
          break
        case '#/maps':
          this.activeIndex = '3'
          break
        default:
          this.activeIndex = ''
          break
      }
    },
    getLocation () {
      if (navigator.geolocation) {
        navigator.geolocation.getCurrentPosition(position => {
          this.locationDetails.lat = position.coords.latitude
          this.locationDetails.lang = position.coords.longitude
          console.log('latlog', this.locationDetails)
          this.$root.$emit('locationDetails', this.locationDetails)
          this.socket.emit('notification', this.locationDetails)
        })
      } else {
        alert('location service not working')
      }
    },
    getNotification (data) {
      if (data.clientID !== localStorage.getItem('DeviceIP')) {
        this.playSound()
        this.$notify.error({
          message: `SOS created on lat: ${data.lat} and lang: ${data.lang}`
        })
      }
    },
    playSound () {
      var audio = new Audio(this.soundurl)
      audio.play()
      setTimeout(() => { audio.stop() }, 5000)
    },
    getIpAddress () {
      axios.get('https://api.ipify.org/?format').then(
        response => {
          console.log(response.data.ip)
          this.getRegisterName(response.data.ip)
          this.formData.deviceIP = response.data
          this.user.clientIP = response.data
          // this.$root.$emit('DeviceIP', this.formData.deviceIP)
          localStorage.setItem('DeviceIP', this.formData.deviceIP)
          this.streamData.clientIP = response.data
          Constant.Client_IP = response.data
        }
      ).catch(error => {
        console.log(error)
      })
    },
    getRegisterName (ip) {
      let data = {
        name: this.makeid(5),
        ip: ip
      }
      this.formData.name = data.name
      console.log(JSON.stringify(data))
    },
    registerDevice () {
      // const URL = baseUrl.baseUrl_NodeProxy + '/device_ip'
      const URL = 'https://localhost:5000/device_ip'
      let deviceConfig = {
        header: {
          'Content-Type': 'application/json'
        }
      }
      console.log('dddd', this.formData)
      axios.post(URL, this.formData, deviceConfig).then(
        response => {
          console.log(response.data)
          this.hideForm()
        }
      ).catch(error => {
        console.log(error)
        this.hideForm()
      })
    },

    /** **Login******/
    userLogin () {
      this.$router.push('/admin')
      // const URL = baseUrl.baseUrl_NodeProxy + '/Login'
      const URL = 'https://localhost:5000/Login'
      let userconfig = {
        header: {
          'Content-Type': 'application/json'
        }
      }
      console.log('dddd', this.user)
      axios.post(URL, this.user, userconfig).then(
        response => {
          if (response.status === 200) {
            this.$router.push('/live')
          }
        }
      ).catch(error => {
        console.log(error)
        this.hideForm()
      })
    },
    makeid (length) {
      let characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'
      let result = ''
      const charactersLength = characters.length
      for (let i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength))
      }
      return result
    },
    myEventHandler (e) {
      if (e.target.innerWidth <= 900) {
        this.isCollapse = true
      }
    },
    openSidebar () {
      this.isCollapse = !this.isCollapse
    },
    handleOpen (key, keyPath) {
      console.log(key, keyPath)
    },
    handleClose (key, keyPath) {
      console.log(key, keyPath)
    },
    jumpLogoTo () {
      if (!this.$route.path.includes('/')) {
        this.$router.push('/')
      }
    },
    goTovideoPage () {
      this.isCollapse = !this.isCollapse
      if (!this.$route.path.includes('/live')) {
        this.$router.push('/live')
      }
    },
    selTheme () {
      this.isCollapse = !this.isCollapse
    },
    beforeUpload () {
      this.isCollapse = !this.isCollapse
      this.dialogvideoFrom = true
    },
    loadMaps () {
      this.isCollapse = !this.isCollapse
      if (!this.$route.path.includes('/maps')) {
        this.$router.push('/maps')
      }
    },
    // Check the video file size
    referenceUpload (e) {
      if (e.currentTarget.files[0].size > 1024 * 1024 * 100) {
        alert('File too big (> 100MB) please make sure video file should be lessThen 100mb')
        this.clearUpload()
      } else {
        this.videoFile = e.currentTarget.files[0]
      }
    },
    // Upload video
    uploadVideoFile () {
      axios.post(baseUrl.baseUrl_NodeProxy + '/uploadStreamdata', this.streamData).then(
        response => {
          console.log('coming to proxy')
          this.clearUpload()
          this.$notify({
            message: 'Video or StreamUrl uploded',
            type: 'success'
          })
        }
      )
        .catch(error => {
          this.errorMessage = error.message
          this.$notify.error({
            message: 'Error in Upload Video'
          })
          this.clearUpload()
        })
    },
    // clear Upload
    clearUpload () {
      this.uploadReady = false
      this.$nextTick(() => {
        this.uploadReady = true
      })
    },
    openForm () {
      this.dialogFormVisible = true
      console.log('visible')
    },
    openLogin () {
      this.loginForm = true
      console.log('visible')
    },
    hideLogin () {
      this.loginForm = false
    },
    // Clear form
    hideForm () {
      this.dialogFormVisible = false
    }
  }
}
</script>

<style lang='less' scoped>
.navgation{
  background-image: linear-gradient(to right, #1e50b5, #e28c0a);
  // background-image: linear-gradient(to right, #650675, #115286, #F0F3FA);
  box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
  height: 65px;
  top: 0px;
  width: 100%;
  position: fixed;
  z-index: 2;
  display: flex;
  .logo{
    height:65px;
    width:200px;
    line-height: 65px;
    margin-left:17px;
    img{
      position: relative;
      top: 0px;
      width:150px;
      cursor: pointer;
    }
  }
  .logo-header{
    font-size: 23px;
    color: white;
    font-weight: bold;
    margin: 0% !important;
    height: 65px;
  }
  .AddDetais{
    display: flex;
    height:65px;
    width:20%;
    justify-content: flex-end;
    align-items: center
  }
  .video-input {
    padding: 1%;
    border: 1px solid #9e9e9e33;
    width: 400px;
  }
  .upload-video {
      font-size: 16px;
      font-weight: bold;
      padding: 15px;
      width: 125px;
  }
  .upload-video-con {
      text-align: center;
      position: relative;
      top: 15px;
  }
  .display-none {
    display: block;
  }
  .display-block {
    display: none
  }
  .el-menu-vertical-demo {
    display: none
  }
  .upLoad_btn {
    height: 42px;
    margin-top: 10px;
  }
  .uploadForm {
    flex-direction: column !important;
  }
  .uploadURL{
    display: flex;
    flex-direction:row;
    justify-content:center
  }
  .StreamURL_input {
    width: 400px !important;
  }
  .or-con {
    padding-top: 35px;
    text-align: center;
    font-weight: bold;
  }
}
@media(max-width:900px) {
  // .display-none {
  //   display: none;
  // }
  .display-block {
    display: block
  }
  .mobile-navgation {
    background-image: linear-gradient(to right, #1e50b5, #e28c0a);
    box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
    height: 65px;
    top: 0px;
    width: 100%;
    position: fixed;
    z-index: 2;
    display: flex;
    .logo{
        height: 65px;
        width: 50px;
        line-height: 65px;
        margin-left: 10px;
      img{
        position: relative;
        top: 10px;
        width: 40px;
        cursor: pointer;
      }
    }
    .logo-header{
      font-size: 25px;
      color: white;
      font-weight: bold;
      height: 65px;
      text-align: center;
      padding-top: 20px;
    }
    .el-dropdown{
      padding-top: 10px !important;
    }
    .login_icon{
      font-size: 30px;
      position: absolute;
      right: 20px;
    }
    .el-menu-vertical-demo:not(.el-menu--collapse) {
      width: 200px;
      margin-left: -10px;
      margin-top: -10px;
      font-size: 20px;
    }
    .el-menu--collapse {
      width: 0px !important;
      margin-left: -10px;
      display: block;
    }
    .el-menu {
      border: none !important;
      height: 100%;
      position: fixed;
      background-color: #8bd3d1;
    }
    .el-menu-item {
      font-size: 18px;
    }
  }
}
</style>
